;========================================================================================
;  stupsnd.s
;  Copyright (C) 2003-2023 Makoto Kamada
;
;  This file is part of the XEiJ (X68000 Emulator in Java).
;  You can use, modify and redistribute the XEiJ if the conditions are met.
;  Read the XEiJ License for more details.
;  https://stdkmd.net/xeij/
;========================================================================================

;----------------------------------------------------------------
;	function
;	@\
;		turn on/off startup sound switch of X68030 or higher and IPLROM 1.6
;		X68030ȏIPLROM 1.6̋ÑXCb`ON/OFF܂
;	options
;	IvV
;		> stupsnd     .... check startup sound switch
;			ÑXCb`mF܂
;		> stupsnd on  .... turn on startup sound switch
;			ÑXCb`ONɂ܂
;		> stupsnd off .... turn off startup sound switch
;			ÑXCb`OFFɂ܂
;----------------------------------------------------------------

	.include	control2.mac
	.include	doscall.mac
	.include	iocscall.mac
	.include	sram.equ
	.include	sysport.equ

;ROM̃o[WmF
	IOCS	_ROMVER
	if	<cmp.l #$13000000,d0>,lo	;1.3ȏłȂ
		lea.l	message_romver(pc),a3
		goto	print_and_exit
	endif

;󔒂ǂݔ΂
	lea.l	1(a2),a0		;
	do
		move.b	(a0)+,d0
	whileor	<cmp.b #' ',d0>,eq,<cmp.b #9,d0>,eq	;
	subq.l	#1,a0

;1ڂo
	moveq.l	#0,d7			;1ڂ̖4
	dostart
		lsl.l	#8,d7
		move.b	d0,d7
	start
		move.b	(a0)+,d0
		ifand	<cmp.b #'A',d0>,hs,<cmp.b #'Z',d0>,ls	;啶
			add.b	#'a'-'A',d0		;ɂ
		endif
	whileand	<cmp.b #'a',d0>,hs,<cmp.b #'z',d0>,ls	;p
	subq.l	#1,a0
;>d7.l:1ڂ̖4

;󔒂ǂݔ΂
	do
		move.b	(a0)+,d0
	whileor	<cmp.b #' ',d0>,eq,<cmp.b #9,d0>,eq	;
	subq.l	#1,a0

;mF
	goto	<tst.b d0>,ne,usage_and_exit	;pȊO̕܂2ڂ
	ifand	<tst.l d7>,ne,<cmp.l #'on',d7>,ne,<cmp.l #'off',d7>,ne	;1ڂ邪onłoffłȂ
usage_and_exit:
		lea.l	message_options(pc),a3
		goto	print_and_exit
	endif
;<d7.l:0=ݒ肵Ȃ,'on'=ONɂ,'off'=OFFɂ

;݂̐ݒmF
	lea.l	SRAM_STARTUP_SOUND,a1
	IOCS	_B_BPEEK
	move.l	#'on',d6
	if	<tst.b d0>,eq
		move.l	#'off',d6
	endif

;ݒ肷
	ifor	<tst.l d7>,eq,<cmp.l d6,d7>,eq	;ݒ肵Ȃ܂͕ωȂ
		lea.l	message_ison(pc),a3
		if	<cmp.l #'off',d6>,eq
			lea.l	message_isoff(pc),a3
		endif
	else				;ݒ肷
		lea.l	SYSPORT_SRAM,a1
		moveq.l	#$31,d1			;SRAM݋
		IOCS	_B_BPOKE
		lea.l	SRAM_STARTUP_SOUND,a1
		lea.l	message_turnedon(pc),a3
		moveq.l	#1,d1			;ONɂ
		if	<cmp.l #'off',d7>,eq
			lea.l	message_turnedoff(pc),a3
			moveq.l	#0,d1			;OFFɂ
		endif
		IOCS	_B_BPOKE
		lea.l	SYSPORT_SRAM,a1
		moveq.l	#0,d1			;SRAM݋֎~
		IOCS	_B_BPOKE
	endif

;bZ[W\ďI
;<a3.l:bZ[W̃AhX
print_and_exit:
	move.l	a3,-(sp)
	DOS	_PRINT
	addq.l	#4,sp
	DOS	_EXIT

;bZ[W
message_romver:
	.dc.b	'unsupported ROM version',13,10,0
message_options:
	.dc.b	'turn on/off startup sound switch of X68030 or higher and IPLROM 1.6',13,10
	.dc.b	'> stupsnd     .... check startup sound switch',13,10
	.dc.b	'> stupsnd on  .... turn on startup sound switch',13,10
	.dc.b	'> stupsnd off .... turn off startup sound switch',13,10,0
message_ison:
	.dc.b	'startup sound switch is on',13,10,0
message_isoff:
	.dc.b	'startup sound switch is off',13,10,0
message_turnedon:
	.dc.b	'startup sound switch turned on',13,10,0
message_turnedoff:
	.dc.b	'startup sound switch turned off',13,10,0

	.end
